SoundPortFlag equ 0fe09h

Tone equ 1813h

    dseg
SoundProc_: public SoundProc_
    defw 0

cseg
InitSound_: public InitSound_
    push hl
        ld hl,0
        ld (SoundProc_),hl
    pop hl
ret


CallSound:
jp (hl)

CallSound_: public CallSound_
    push af | push hl
    ld hl,(SoundProc_)
    ld a,l
    or h
    if nz
        call CallSound
        ld hl,0
        ld (SoundProc_),hl
    endif
    pop hl | pop af
ret


Sound_Hit:
    push af | push hl | push de | push bc
        ld a,12+12
        do
            push af
                ld de,1
                call Tone
            pop af
            inc a
            cp 36+12
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
Sound_Hit_:  public Sound_Hit_
    push hl
        ld hl,Sound_Hit
        ld (SoundProc_),hl
    pop hl
ret


Melody: 
; in
;   hl: address
    push af | push hl | push de | push bc
        do
            ld c,(hl) | inc hl
            ld b,(hl) | inc hl

            ld a,c
            add a,a
            ; add a,c
            ld c,a
            ; ld a,c
            or a
        while nz
            ld a,b
            or a
            if nz
                ld e,c
                ld d,0
                push hl
                    call Tone
                pop hl
            else
                push hl
                    do
                        ld hl,(0fe9eh)
                        ld a,l
                        or h
                    while nz | wend
                    ld l,c
                    ld h,0
                    di
                        ld (0fe9eh),hl
                    ei
                pop hl
            endif
        wend
    pop bc | pop de | pop hl | pop af
ret


beep_notes:
    defb 3,A4, 3,0, 0
Sound_Beep_: public Sound_Beep_
    push af | push hl
        ld hl,beep_notes
        call Melody
    pop hl | pop af
ret


loose_notes:
    defb 3,A3, 3,0, 0
Sound_Loose_: public Sound_Loose_
    push af | push hl
        ld hl,loose_notes
        call Melody
    pop hl | pop af
ret


start_notes:
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 47,C5,1,0
    defb 0
Sound_Start_:
    public Sound_Start_
    push af | push hl | push de | push bc
        ld hl,start_notes
        call Melody
    pop bc | pop de | pop hl | pop af
ret

clear_notes:
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0
	defb 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear_: 
    public Sound_Clear_
    push af | push hl | push de | push bc
        ld hl,clear_notes
        call Melody
    pop bc | pop de | pop hl | pop af
ret

over_notes:
	defb 5,C5,1,0, 5,C5,1,0, 5,G4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 5,B4,1,0
	defb 30,C5,18,0
    defb 0
Sound_GameOver_: 
    public Sound_GameOver_
    push af | push hl | push de | push bc
        ld hl,over_notes
        call Melody
    pop bc | pop de | pop hl | pop af
ret


A3 equ 45-12

C4 equ 48-12
C4S equ 49-12
D4 equ 50-12
E4 equ 52-12
F4 equ 53-12
G4 equ 55-12
A4 equ 57-12
B4 equ 59-12
C5 equ 60-12
D5 equ 62-12
E5 equ 64-12
F5 equ 65-12
